local _, addon = ...
local L, bool, print, _print = addon.L, addon.bool, addon.print, addon._print
local worker = CreateFrame("Frame")
local rollIndex = "AAA" -- fist when sorted

local _G = _G
local ACTION_SPELL_MISSED_DODGE = ACTION_SPELL_MISSED_DODGE
local ACTION_SPELL_MISSED_EVADE = ACTION_SPELL_MISSED_EVADE
local BACKPACK_CONTAINER = BACKPACK_CONTAINER
local BONUS_ROLL_ROLLING = BONUS_ROLL_ROLLING
local ChatFrame_AddMessageEventFilter = ChatFrame_AddMessageEventFilter
local ChatFrame_AddMessageGroup = ChatFrame_AddMessageGroup
local ChatFrame_RemoveAllChannels = ChatFrame_RemoveAllChannels
local ChatFrame_RemoveAllMessageGroups = ChatFrame_RemoveAllMessageGroups
local ChatFrame_RemoveMessageEventFilter = ChatFrame_RemoveMessageEventFilter
local COPPER_AMOUNT = COPPER_AMOUNT
local DEFAULT_CHAT_FRAME = DEFAULT_CHAT_FRAME
local ERR_QUEST_REWARD_EXP_I = ERR_QUEST_REWARD_EXP_I
local ERR_QUEST_REWARD_MONEY_S = ERR_QUEST_REWARD_MONEY_S
local FCF_Close = FCF_Close
local FCF_GetChatWindowInfo = FCF_GetChatWindowInfo
local FCF_OpenNewWindow = FCF_OpenNewWindow
local format = format
local FRIENDS_FRIENDS_CHOICE_EVERYONE = FRIENDS_FRIENDS_CHOICE_EVERYONE
local GetCoinTextureString = GetCoinTextureString
local GetContainerItemInfo = GetContainerItemInfo
local GetContainerNumSlots = GetContainerNumSlots
local GetCurrencyInfo = GetCurrencyInfo
local GetCurrencyLink = GetCurrencyLink
local GetCurrencyListInfo = GetCurrencyListInfo
local GetCurrencyListLink = GetCurrencyListLink
local GetCurrencyListSize = GetCurrencyListSize
local GetCVarBool = GetCVarBool
local GetDenominationsFromCopper = GetDenominationsFromCopper
local GetGuildInfo = GetGuildInfo
local GetInboxHeaderInfo = GetInboxHeaderInfo
local GetInboxItem = GetInboxItem
local GetInboxItemLink = GetInboxItemLink
local GetItemIcon = GetItemIcon
local GetItemInfo = GetItemInfo
local GetLFGMode = GetLFGMode
local GetMoney = GetMoney
local GetTargetTradeMoney = GetTargetTradeMoney
local GetTime = GetTime
local GetTradeTargetItemInfo = GetTradeTargetItemInfo
local GetTradeTargetItemLink = GetTradeTargetItemLink
local GOLD_AMOUNT = GOLD_AMOUNT
local GREED = GREED
local GUILD = GUILD
local HONOR = HONOR
local hooksecurefunc = hooksecurefunc
local HP = HP
local InCombatLockdown = InCombatLockdown
local ipairs = ipairs
local isMasterLoot = isMasterLoot
local IsMasterLooter = IsMasterLooter
local IsModifiedClick = IsModifiedClick
local LE_LFG_CATEGORY_LFR = LE_LFG_CATEGORY_LFR
local LOOT_DISENCHANT_CREDIT = LOOT_DISENCHANT_CREDIT
local LOOT_ITEM_PUSHED_SELF_MULTIPLE = LOOT_ITEM_PUSHED_SELF_MULTIPLE
local math = math
local MAX_TRADE_ITEMS = MAX_TRADE_ITEMS
local NEED = NEED
local next = next
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
local NUM_CHAT_WINDOWS = NUM_CHAT_WINDOWS
local pairs = pairs
local PASS = PASS
local ROLL_DISENCHANT = ROLL_DISENCHANT
local select = select
local SetItemRef = SetItemRef
local SILVER_AMOUNT = SILVER_AMOUNT
local StaticPopup_Show = StaticPopup_Show
local table = table
local tonumber = tonumber
local tostring = tostring
local type = type
local UnitName = UnitName
local unpack = unpack
local XP = XP
local YOU_LOOT_MONEY = YOU_LOOT_MONEY

addon.loaded = {}
addon.events = {}
addon.queue = {}

addon.matches = {
  CHAT_MSG_COMBAT_FACTION_CHANGE = { -- name(faction), value(rep), type(1/nil for inc/dec)
    [1] = {FACTION_STANDING_DECREASED = {1, 2, nil}},
    [2] = {FACTION_STANDING_DECREASED_GENERIC = {1, nil, nil}},
    [3] = {FACTION_STANDING_INCREASED = {1, 2, 1}},
    [4] = {FACTION_STANDING_INCREASED_BONUS = {1, 2, 1}},
    [5] = {FACTION_STANDING_INCREASED_GENERIC = {1, nil, 1}},
  },
  CHAT_MSG_COMBAT_HONOR_GAIN = { -- points(honor), source(name), rank(int)
    [1] = {COMBATLOG_HONORAWARD = {1, nil, nil}},
    [2] = {COMBATLOG_HONORGAIN = {3, 1, 2}},
    [3] = {COMBATLOG_HONORGAIN_NO_RANK = {2, 1, nil}},
  },
  CHAT_MSG_COMBAT_XP_GAIN = { -- points(exp), source(name), isLost(1/nil for lost or gained)
    [1] = {COMBATLOG_XPGAIN_EXHAUSTION1 = {2, 1, nil}},
    [2] = {COMBATLOG_XPGAIN_EXHAUSTION1_GROUP = {2, 1, nil}},
    [3] = {COMBATLOG_XPGAIN_EXHAUSTION1_RAID = {2, 1, nil}},
    [4] = {COMBATLOG_XPGAIN_EXHAUSTION2 = {2, 1, nil}},
    [5] = {COMBATLOG_XPGAIN_EXHAUSTION2_GROUP = {2, 1, nil}},
    [6] = {COMBATLOG_XPGAIN_EXHAUSTION2_RAID = {2, 1, nil}},
    [7] = {COMBATLOG_XPGAIN_EXHAUSTION4 = {2, 1, nil}},
    [8] = {COMBATLOG_XPGAIN_EXHAUSTION4_GROUP = {2, 1, nil}},
    [9] = {COMBATLOG_XPGAIN_EXHAUSTION4_RAID = {2, 1, nil}},
    [10] = {COMBATLOG_XPGAIN_EXHAUSTION5 = {2, 1, nil}},
    [11] = {COMBATLOG_XPGAIN_EXHAUSTION5_GROUP = {2, 1, nil}},
    [12] = {COMBATLOG_XPGAIN_EXHAUSTION5_RAID = {2, 1, nil}},
    [13] = {COMBATLOG_XPGAIN_FIRSTPERSON = {2, 1, nil}},
    [14] = {COMBATLOG_XPGAIN_FIRSTPERSON_GROUP = {2, 1, nil}},
    [15] = {COMBATLOG_XPGAIN_FIRSTPERSON_RAID = {2, 1, nil}},
    [16] = {COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED = {1, nil, nil}},
    [17] = {COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED_GROUP = {1, nil, nil}},
    [18] = {COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED_RAID = {1, nil, nil}},
    [19] = {COMBATLOG_XPGAIN_QUEST = {1, nil, nil}},
    [20] = {COMBATLOG_XPLOSS_FIRSTPERSON_UNNAMED = {1, nil, 1}},
  },
  CHAT_MSG_CURRENCY = { -- name(item, no link), count(int), target(name)
    [1] = {CURRENCY_GAINED_MULTIPLE = {1, 2, nil}},
    [2] = {CURRENCY_GAINED = {1, nil, nil}},
  },
  CHAT_MSG_LOOT = { -- name(item), count(int), target(name)
    [1] = {LOOT_ITEM_CREATED_SELF_MULTIPLE = {1, 2, nil}},
    [2] = {LOOT_ITEM_CREATED_SELF = {1, nil, nil}},
    [3] = {LOOT_ITEM_PUSHED_SELF_MULTIPLE = {1, 2, nil}},
    [4] = {LOOT_ITEM_PUSHED_SELF = {1, nil, nil}},
    [5] = {LOOT_ITEM_SELF_MULTIPLE = {1, 2, nil}},
    [6] = {LOOT_ITEM_SELF = {1, nil, nil}},
    [7] = {LOOT_ITEM_MULTIPLE = {2, 3, 1}},
    [8] = {LOOT_ITEM = {2, nil, 1}},
    [9] = {CREATED_ITEM_MULTIPLE = {2, 3, 1}},
    [10] = {CREATED_ITEM = {2, nil, 1}},
    -- roll handling; item(name), player(name), roll(int), type(nil or 1:disenchant, 2:greed, 3:need, 4:lost), isInstant
    [11] = {LOOT_ROLL_YOU_WON_NO_SPAM_NEED = {3, nil, 2, 3, nil}},
    [12] = {LOOT_ROLL_YOU_WON_NO_SPAM_GREED = {3, nil, 2, 2, nil}},
    [13] = {LOOT_ROLL_YOU_WON_NO_SPAM_DE = {3, nil, 2, 1, nil}},
    [14] = {LOOT_ROLL_WON_NO_SPAM_NEED = {4, 2, 3, 3, nil}},
    [15] = {LOOT_ROLL_WON_NO_SPAM_GREED = {4, 2, 3, 2, nil}},
    [16] = {LOOT_ROLL_WON_NO_SPAM_DE = {4, 2, 3, 1, nil}},
    [17] = {LOOT_ROLL_ROLLED_NEED_ROLE_BONUS = {2, 3, 1, 3, nil}},
    [18] = {LOOT_ROLL_ROLLED_NEED = {2, 3, 1, 3, nil}},
    [19] = {LOOT_ROLL_ROLLED_GREED = {2, 3, 1, 2, nil}},
    [20] = {LOOT_ROLL_ROLLED_DE = {2, 3, 1, 1, nil}},
    [21] = {LOOT_ROLL_LOST_ROLL = {}}, -- ?
    -- instant roll decision info; item(name), player(name), type(nil:pass, 1:disenchant, 2:greed, 3:need, 4:allPass, 5:rollStarted, 6:won), dummy(nil), isInstant
    [22] = {LOOT_ROLL_YOU_WON = {1, nil, 6, nil, 1}},
    [23] = {LOOT_ROLL_WON = {2, 1, 6, nil, 1}},
    [24] = {LOOT_ROLL_ALL_PASSED = {2, nil, 4, nil, 1}},
    [25] = {LOOT_ROLL_PASSED_SELF_AUTO = {2, nil, nil, nil, 1}},
    [26] = {LOOT_ROLL_PASSED_SELF = {2, nil, nil, nil, 1}},
    [27] = {LOOT_ROLL_PASSED_AUTO_FEMALE = {2, 1, nil, nil, 1}},
    [28] = {LOOT_ROLL_PASSED_AUTO = {2, 1, nil, nil, 1}},
    [29] = {LOOT_ROLL_PASSED = {2, 1, nil, nil, 1}},
    [30] = {LOOT_ROLL_NEED_SELF = {2, nil, 3, nil, 1}},
    [31] = {LOOT_ROLL_NEED = {2, 1, 3, nil, 1}},
    [32] = {LOOT_ROLL_GREED_SELF = {2, nil, 2, nil, 1}},
    [33] = {LOOT_ROLL_GREED = {2, 1, 2, nil, 1}},
    [34] = {LOOT_ROLL_DISENCHANT_SELF = {2, nil, 1, nil, 1}},
    [35] = {LOOT_ROLL_DISENCHANT = {2, 1, 1, nil, 1}},
    -- roll started; item(name), rollId(int), isRollStart(5), dummy(nil), isInstant
    [36] = {LOOT_ROLL_STARTED = {2, 1, 5, nil, 1}},
  },
  CHAT_MSG_MONEY = { -- gold(money), target(name), unused(nil)
    [1] = {YOU_LOOT_MONEY_GUILD = {1, nil, nil}},
    [2] = {YOU_LOOT_MONEY = {1, nil, nil}},
    [3] = {LOOT_MONEY_SPLIT_GUILD = {1, nil, nil}},
    [4] = {LOOT_MONEY_SPLIT = {1, nil, nil}},
    [5] = {LOOT_MONEY = {2, 1, nil}},
  },
  CHAT_MSG_COMBAT_GUILD_XP_GAIN = { -- points(exp)
    [1] = {COMBATLOG_GUILD_XPGAIN = {1}},
  },
}

addon.petBattle = {
  const = {
    ABILITY_DAMAGE = "damage",
    ABILITY_HEAL = "heal",
    AVOIDANCE_DODGE = "dodge",
    AVOIDANCE_MISS = "miss",
    TARGET_ENEMY = "enemy",
    TARGET_PET = "pet",
    TYPE_CRIT = 2,
    TYPE_NORMAL = 0,
    TYPE_STRONG = 1,
    TYPE_WEAK = -1,
  },
  matches = {
    [1] = {"^(.-) applied (.-) to enemy (.-) %(Critical%)%.$", function(self, source, effect, target)
      --self:EffectTo(source, effect, target == "team" and true or target, self.const.TYPE_CRIT, self.const.TARGET_ENEMY, 1)
      return 1 end},
    [2] = {"^(.-) applied (.-) to enemy (.-) %(Strong%)%.$", function(self, source, effect, target)
      --self:EffectTo(source, effect, target == "team" and true or target, self.const.TYPE_STRONG, self.const.TARGET_ENEMY, 1)
      return 1 end},
    [3] = {"^(.-) applied (.-) to enemy (.-) %(Weak%)%.$", function(self, source, effect, target)
      --self:EffectTo(source, effect, target == "team" and true or target, self.const.TYPE_WEAK, self.const.TARGET_ENEMY, 1)
      return 1 end},
    [4] = {"^(.-) applied (.-) to enemy (.-)%.$", function(self, source, effect, target)
      --self:EffectTo(source, effect, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_ENEMY, 1)
      return 1 end},
    [5] = {"^(.-) dealt (%d-) damage to enemy (.-) %(Critical%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_CRIT, self.const.TARGET_ENEMY, self.const.ABILITY_DAMAGE)
      return 1 end},
    [6] = {"^(.-) dealt (%d-) damage to enemy (.-) %(Strong%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_STRONG, self.const.TARGET_ENEMY, self.const.ABILITY_DAMAGE)
      return 1 end},
    [7] = {"^(.-) dealt (%d-) damage to enemy (.-) %(Weak%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_WEAK, self.const.TARGET_ENEMY, self.const.ABILITY_DAMAGE)
      return 1 end},
    [8] = {"^(.-) dealt (%d-) damage to enemy (.-)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_ENEMY, self.const.ABILITY_DAMAGE)
      return 1 end},
    [9] = {"^(.-) dealt (%d-) damage to your (.-) %(Critical%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_CRIT, self.const.TARGET_PET, self.const.ABILITY_DAMAGE)
      return 1 end},
    [10] = {"^(.-) dealt (%d-) damage to your (.-) %(Strong%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_STRONG, self.const.TARGET_PET, self.const.ABILITY_DAMAGE)
      return 1 end},
    [11] = {"^(.-) dealt (%d-) damage to your (.-) %(Weak%)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_WEAK, self.const.TARGET_PET, self.const.ABILITY_DAMAGE)
      return 1 end},
    [12] = {"^(.-) dealt (%d-) damage to your (.-)%.$", function(self, source, damage, target)
      self:DealtNumbersTo(source, damage, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_PET, self.const.ABILITY_DAMAGE)
      return 1 end},
    [13] = {"^(.-) fades from enemy (.-)%.$", function(self, effect, target)
      --self:EffectTo(nil, effect, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_ENEMY, nil)
      return 1 end},
    [14] = {"^(.-) fades from your (.-)%.$", function(self, effect, target)
      --self:EffectTo(nil, effect, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_PET, nil)
      return 1 end},
    [15] = {"^(.-) healed (%d-) damage from enemy (.-)%.$", function(self, effect, health, target)
      self:DealtNumbersTo(effect, health, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_ENEMY, self.const.ABILITY_HEAL)
      return 1 end},
    [16] = {"^(.-) healed (%d-) damage from your (.-)%.$", function(self, effect, health, target)
      self:DealtNumbersTo(effect, health, target == "team" and true or target, self.const.TYPE_NORMAL, self.const.TARGET_PET, self.const.ABILITY_HEAL)
      return 1 end},
    [17] = {"^(.-) is now enemy active pet%.$", function(self, target)
      self:ActiveEnemy(target)
      return 1 end},
    [18] = {"^(.-) is now your active pet%.$", function(self, target)
      self:ActivePet(target)
      return 1 end},
    [19] = {"^(.-) missed enemy (.-)%.$", function(self, ability, target)
      self:AvoidedTo(ability, target == "team" and true or target, self.const.TARGET_ENEMY, self.const.AVOIDANCE_MISS)
      return 1 end},
    [20] = {"^(.-) missed your (.-)%.$", function(self, ability, target)
      self:AvoidedTo(ability, target == "team" and true or target, self.const.TARGET_PET, self.const.AVOIDANCE_MISS)
      return 1 end},
    [21] = {"^(.-) was dodged by enemy (.-)%.$", function(self, ability, target)
      self:AvoidedTo(ability, target == "team" and true or target, self.const.TARGET_ENEMY, self.const.AVOIDANCE_DODGE)
      return 1 end},
    [22] = {"^(.-) was dodged by your (.-)%.$", function(self, ability, target)
      self:AvoidedTo(ability, target == "team" and true or target, self.const.TARGET_PET, self.const.AVOIDANCE_DODGE)
      return 1 end},
    [23] = {"^Enemy (.-) died%.$", function(self, target)
      self:DealtDeathTo(target, "enemy")
      return 1 end},
    [24] = {"^Your (.-) died%.$", function(self, target)
      self:DealtDeathTo(target, "pet")
      return 1 end},
    [25] = {"^Round (%d-)$", function(self, round)
      return 1 end},
    [26] = {"^Your (.-) gains (%d-) XP%.$", function(self, target, experience)
      self:GainedXP(target, experience)
      return 1 end},
    [27] = {"^Your (.-) has reached Level (%d-)%!$", function(self, target, level)
      self:GainedLevel(target, level)
      return 1 end},
    [28] = {"^(.-) trapped enemy (.-)%.$", function(self, trap, target)
      self:Trapped(trap, target)
      return 1 end},
  },
  --[[
  EffectTo = function(self, source, effect, target2, status, receiver, nil1)
    if type(self.combat[receiver]) ~= "table" then
      self.combat[receiver] = {}
    end
    if target2 == true then
      -- TODO: NYI when it's done to the whole party -we need to figure out how to deal with the identification issue of who is who (API vs. chat messages)
    else
      if type(self.combat[receiver][target2]) ~= "table" then
        self.combat[receiver][target2] = {}
      end
      self.combat[receiver][target2][effect] = nil1
    end
  end,
  ]]
  DealtNumbersTo = function(self, source, number, target2, status, receiver, healOrDamage)
    if type(self.combat[receiver]) ~= "table" then
      self.combat[receiver] = {}
    end
    if target2 == true then
      -- TODO: NYI when it's done to the whole party -we need to figure out how to deal with the identification issue of who is who (API vs. chat messages)
    else
      if type(self.combat[receiver][target2]) ~= "table" then
        self.combat[receiver][target2] = {}
      end
      if type(self.combat[receiver][target2][healOrDamage]) ~= "number" then
        self.combat[receiver][target2][healOrDamage] = 0
      end
      self.combat[receiver][target2][healOrDamage] = self.combat[receiver][target2][healOrDamage] + (tonumber(number) or 0)
    end
  end,
  ActiveEnemy = function(self, target)
    self.combat.activeEnemy = target
    if self.combat.activePet and self.combat.activeEnemy then
      print("|cffFFCC00Your|r |cff55FF55"..self.combat.activePet.."|r |cffFFCC00versus|r |cffFF5555"..self.combat.activeEnemy.."|r|cffFFCC00.|r")
    end
  end,
  ActivePet = function(self, target)
     self.combat.activePet = target
      if self.combat.activePet and self.combat.activeEnemy then
        print("|cffFFCC00Your|r |cff55FF55"..self.combat.activePet.."|r |cffFFCC00versus|r |cffFF5555"..self.combat.activeEnemy.."|r|cffFFCC00.|r")
      end
  end,
  AvoidedTo = function(self, ability, target2, receiver, missOrDodge)
    if type(self.combat[receiver]) ~= "table" then
      self.combat[receiver] = {}
    end
    if target2 == true then
      -- TODO: NYI when it's done to the whole party -we need to figure out how to deal with the identification issue of who is who (API vs. chat messages)
    else
      if type(self.combat[receiver][target2]) ~= "table" then
        self.combat[receiver][target2] = {}
      end
      if type(self.combat[receiver][target2][missOrDodge]) ~= "number" then
        self.combat[receiver][target2][missOrDodge] = 0
      end
      self.combat[receiver][target2][missOrDodge] = self.combat[receiver][target2][missOrDodge] + 1
    end
  end,
  DealtDeathTo = function(self, target, receiver)
    if type(self.combat.death) ~= "table" then
      self.combat.death = {}
    end
    if type(self.combat.death[receiver]) ~= "table" then
      self.combat.death[receiver] = {}
    end
    self.combat.death[receiver][target] = 1
  end,
  GainedXP = function(self, target, experience)
    if type(self.combat.xp) ~= "table" then
      self.combat.xp = {}
    end
    if type(self.combat.xp[target]) ~= "number" then
      self.combat.xp[target] = 0
    end
    self.combat.xp[target] = self.combat.xp[target] + experience
  end,
  GainedLevel = function(self, target, level)
    if type(self.combat.level) ~= "table" then
      self.combat.level = {}
    end
    self.combat.level[target] = level -- TODO: what about when we have two pets with the same name?
  end,
  Trapped = function(self, trap, target)
    if type(self.combat.trapped) ~= "table" then
      self.combat.trapped = {}
    end
    self.combat.trapped[target] = trap
  end,
  round = 0,
  combat = {},
  NewRound = function(self, isFirst)
    if isFirst then
      self.round = 0
    else
      self.round = self.round + 1
    end
    table.wipe(self.combat)
  end,
  EndCombat = function(self)
    if type(self.combat) == "table" then
      if type(self.combat.trapped) == "table" then
        local temp = ""
        for target, trap in pairs(self.combat.trapped) do
          temp = temp..target.." "
        end
        if temp:len() > 1 then
          print("|cff55FF55You have caught "..temp:sub(1, temp:len() - 1).."!|r")
        end
      end
      local temp = {}
      if type(self.combat.level) == "table" then
        for target, level in pairs(self.combat.level) do
          temp[target] = level
        end
      end
      if type(self.combat.xp) == "table" then
        for target, xp in pairs(self.combat.xp) do
          if temp[target] then
            print("|cff55FF55"..target.." gained "..xp.." XP and dinged level "..temp[target].."!|r")
            temp[target] = nil
          else
            print("|cff55FF55"..target.." gained "..xp.." XP!|r")
          end
        end
      end
    end
    self.round = 0
    table.wipe(self.combat)
  end,
  CombatLog = function(self, message)
    local data = nil
    for _, matchFunc in ipairs(self.matches) do
      data = {message:match(matchFunc[1])}
      if next(data) then
        return matchFunc[2](self, unpack(data))
      end
    end
  end,
  PrintRoundSummary = function(self, isOpening)
    if isOpening then return end
    local receivers, numberTypes, avoidanceTypes = {self.const.TARGET_PET, self.const.TARGET_ENEMY}, {self.const.ABILITY_DAMAGE, self.const.ABILITY_HEAL}, {self.const.AVOIDANCE_MISS, self.const.AVOIDANCE_DODGE}
    local temp, damage, heal, dodge, miss, hpdiff
    for _, receiver in ipairs(receivers) do
      if type(self.combat[receiver]) == "table" then
        for target, targetData in pairs(self.combat[receiver]) do
          temp, damage, heal, dodge, miss = "", 0, 0, 0, 0
          for _, numberType in ipairs(numberTypes) do
            if numberType == self.const.ABILITY_DAMAGE then
              damage = damage + (self.combat[receiver][target][numberType] or 0)
            elseif numberType == self.const.ABILITY_HEAL then
              heal = heal + (self.combat[receiver][target][numberType] or 0)
            end
          end
          for _, avoidanceType in ipairs(avoidanceTypes) do
            if avoidanceType == self.const.AVOIDANCE_MISS then
              miss = miss + (self.combat[receiver][target][avoidanceType] or 0)
            elseif avoidanceType == self.const.AVOIDANCE_DODGE then
              dodge = dodge + (self.combat[receiver][target][avoidanceType] or 0)
            end
          end
          hpdiff = damage - heal
          if hpdiff < 0 then
            temp = temp.."|cff55FF55"..math.abs(hpdiff)..HP.."|r "
          elseif hpdiff > 0 then
            temp = temp.."|cffFF5555"..hpdiff..HP.."|r "
          end
          if dodge > 0 then
            temp = temp.."|cffCCCCCC"..dodge.." "..ACTION_SPELL_MISSED_DODGE.."|r "
          end
          if miss > 0 then
            temp = temp.."|cffCCCCCC"..miss.." "..ACTION_SPELL_MISSED_EVADE.."|r "
          end
          if temp:len() > 1 then
            print("|cff999999R"..self.round.."|r |cff"..(receiver == self.const.TARGET_PET and "55FF55" or (receiver == self.const.TARGET_ENEMY and "FF5555" or "FFFFFF"))..target.."|r "..temp:sub(1, temp:len() - 1))
          end
        end
      end
    end
    if type(self.combat.death) == "table" then
      for _, receiver in ipairs(receivers) do
        if type(self.combat.death[receiver]) == "table" then
          for target, _ in pairs(self.combat.death[receiver]) do
            print("|cff999999R"..self.round.."|r |cff"..(receiver == self.const.TARGET_PET and "55FF55" or (receiver == self.const.TARGET_ENEMY and "FF5555" or "FFFFFF"))..target.."|r died.")
          end
        end
      end
    end
  end,
}

local whenInRF = function(expect, fallback)
  if GetLFGMode(LE_LFG_CATEGORY_LFR) then
    return expect
  end
  if type(fallback) ~= "nil" then
    return fallback and true or false
  end
  return true
end

local validPlayerName = function(str)
  if addon.locale == "ruRU" then
    if str:match(" ") and (not str:match("%+")) then -- if missmatched player name with another string (representing "You" then player name is nil, notice that LFR bonus rolls contain an "+" so keep that in mind)
      str = nil
    end
  end
  return str
end

local stripNameRollBonus = function(str)
  local isBonus = str:match("%+")
  return isBonus and (str:gsub("%+.+$", ""):trim().."") or str, isBonus -- fixes " + Role Bonus" at the end of the name, roll bonuses are always 101-200 so there should not be a need for the description
end

local FormatToMatcher = function(str)
  if type(str) ~= "string" then return "" end
  str = str:gsub("%.", "%%%.") -- "." into "%."
  str = str:gsub("%(", "%%%(") -- "(" into "%("
  str = str:gsub("%)", "%%%)") -- ")" into "%)"
  str = str:gsub("%[", "%%%[") -- "[" into "%["
  str = str:gsub("%]", "%%%]") -- "]" into "%]"
  --str = str:gsub("%|", "%%%|") -- "|" into "%|"
  str = str:gsub("%-", "%%%-") -- "-" into "%-"
  str = str:gsub("%%(%d)%$(%a)", "%%%2") -- "%3$s" into "%s" (works for s and d)
  str = str:gsub("%%%%%.(%d)f", "%%s") -- "%.#f" into "%s" (will have decimal)
  str = str:gsub("%%d", "%(%%d+%)") -- numbers
  str = str:gsub("%%s", "%(%.+%)") -- strings
  return str
end

local MoneyStringToCopper = function(str)
  if type(str) ~= "string" then return 0 end
  str = str:lower()
  local sum = 0
  local gm, sm, cm = FormatToMatcher(GOLD_AMOUNT):lower(), FormatToMatcher(SILVER_AMOUNT):lower(), FormatToMatcher(COPPER_AMOUNT):lower()
  local g, s, c = str:match(gm), str:match(sm), str:match(cm)
  if g then sum = sum + g * 10000 end
  if s then sum = sum + s * 100 end
  if c then sum = sum + c end
  return sum
end

StaticPopupDialogs["MINILOOT_LOOT_WINDOW_OVERWRITE"] = {
  text = format(L.POPUP_CHAT_FRAME_OVERWRITE, addon.lootwin),
  button1 = YES,
  button2 = NO,
  OnAccept = function(self)
    self.LootWindowCreate(1)
  end,
  exclusive = 1,
  whileDead = 1,
  hideOnEscape = 1,
  showAlert = 1,
  timeout = 0,
}

local LootWindowExists = function(name)
  local f, t
  for i = 1, NUM_CHAT_WINDOWS do
    f = _G["ChatFrame"..i]
    t = _G["ChatFrame"..i.."Tab"]
    if f and t and (t:IsVisible() or f.minimized) and name == FCF_GetChatWindowInfo(i) then
      return _G["ChatFrame"..i]
    end
  end
end

local ClearLootWindow = function(name)
  for i = 1, NUM_CHAT_WINDOWS do
    if name == FCF_GetChatWindowInfo(i) then
      FCF_Close(_G["ChatFrame"..i])
    end
  end
end

local LootWindowCreate LootWindowCreate = function(confirmed)
  local LootWindow = LootWindowExists(addon.lootwin)
  if LootWindow and not confirmed then
    StaticPopup_Show("MINILOOT_LOOT_WINDOW_OVERWRITE").LootWindowCreate = LootWindowCreate
  else
    ClearLootWindow(addon.lootwin)
    FCF_OpenNewWindow(addon.lootwin)
    LootWindow = LootWindowExists(addon.lootwin)
    ChatFrame_RemoveAllMessageGroups(LootWindow)
    ChatFrame_RemoveAllChannels(LootWindow)
    for _, chatType in pairs(addon.lootwintypes) do
      ChatFrame_AddMessageGroup(LootWindow, chatType)
    end
  end
end addon.LootWindowCreate = LootWindowCreate

local CurrencyCaches = function()
  local temp, name, isHeader, icon, link = {}
  for i = 1, GetCurrencyListSize() do
    name, isHeader, _, _, _, _, icon = GetCurrencyListInfo(i)
    link = GetCurrencyListLink(i) or ""
    if name and (not isHeader) then
      temp[name] = {tonumber(link:match(":(%d+)")) or i, icon}
    end
  end
  addon.currencies = temp
end

local ArchaeologyCaches = function()
  local name, icon, link
  for _, i in pairs({384, 385, 393, 394, 397, 398, 399, 400, 401, 676, 677}) do -- CurrencyTypes.dbc
    name, _, icon = GetCurrencyInfo(i)
    link = GetCurrencyListLink(i) or ""
    if name and icon then
      addon.currencies[name] = {tonumber(link:match(":(%d+)")) or i, "Interface\\Icons\\"..icon} -- must add the folder path manually
    end
  end
end

local ConvertMatches = function()
  local temp = {}
  for event, data in pairs(addon.matches) do
    temp[event] = {}
    for i = 1, #data do
      temp[event][i] = {}
      for key, tbl in pairs(data[i]) do
        temp[event][i][FormatToMatcher(_G[key])] = tbl
      end
    end
  end
  addon.matches = temp
end

local UCFirst = function(str)
  local temp = ""
  temp = str:sub(1,1):upper()
  return temp..str:sub(2):lower()
end

local Abbrev = function(str)
  local abbr = ""
  local words = {(" "):split(tostring(str))}
  if #words > 1 then
    for _, part in pairs(words) do
      abbr = abbr..UCFirst(part:sub(1,3)) -- try with 3 letters first...
    end
    if abbr:len() > 12 then -- only shorten more if larger than 12 chars!
      abbr = ""
      for _, part in pairs(words) do
        abbr = abbr..UCFirst(part:sub(1,2)) -- using 2 letters as it exceeds the limit with 3!
      end
    end
    return abbr
  end
  return str
end

local GetSelectedWindow = function()
  return _G[MiniLootDB.outputChat] or DEFAULT_CHAT_FRAME
end

local GetFontSize = function()
  return type(MiniLootDB.fontSize) == "number" and MiniLootDB.fontSize > 0 and MiniLootDB.fontSize or (select(2, FCF_GetChatWindowInfo(GetSelectedWindow():GetID())) or 13)-1 -- either use custom fontsize specified or attempt to extract the default size, at worst fallback to 12px!
end

local GetIconWithLink = function(str, iscurrency)
  if type(str) ~= "string" then return "" end -- BUG: maybe fixed, not tested, have to uncomment this and find out!

  if iscurrency then
    str = str:match("|h%[(.+)%]|h")
    local currency = type(addon.currencies) == "table" and addon.currencies[str]
    if type(currency) == "table" then
      --return format("|cff%s|H%s:%s:%d|h[|T%s:%d|t]|h|r", "FFFFFF", addon.name2, "currency", currency[1], currency[2], GetFontSize())
      return format("|cff00AA00|Hcurrency:%d|h[|T%s:%d|t]|h|r", currency[1], currency[2], GetFontSize())
    end
  else
    local color, itemstr, name = str:match("|cff(.+)|Hitem:(.+)|h%[(.+)%]|h|r")
    if color then
      local _, _, _, _, _, class, subclass = GetItemInfo(str)
      if addon:isItemClassQuest(class) or addon:isItemClassQuest(subclass) then -- if quest item color and add additional noticable tags to the output
        if addon:isItemQuestStarter(str) then
          color = "FF3333" -- it starts a quest so instead of heirloom color it's now red!
        else
          color = "E6CC80"
        end
      end
      return format("|cff%s|Hitem:%s|h[|T%s:%d|t]|h|r", color, itemstr, GetItemIcon(str), GetFontSize()) -- font size corresponds to chat font size (uses currently set size)
    end
  end
  return str
end addon.GetIconWithLink = GetIconWithLink

local NewLine = function(str)
  if str:sub(str:len()) ~= "\n" then
    return str.."\n" -- add new line if does not exist from before (at the end)
  end
  return str
end

local UpdRepLoot = function(tbl, data)
  if not data[1] then return end -- no faction name, no entry!
  tbl[data[1]] = (tbl[data[1]] or 0) + (math.abs(data[2]) * data[3]) -- insert or update faction rep value (data[3] modifies if it's gained or lost)
end

local UpdHonorLoot = function(tbl, data)
  if not data[1] then return end -- no honor value, no entry!
  tbl[1] = (tbl[1] or 0) + data[1]
end

local UpdXPLoot = function(tbl, data)
  if not data[1] then return end -- no xp value, no entry!
  tbl[1] = (tbl[1] or 0) + (math.abs(data[1]) * data[3]) -- insert or update xp value (data[3] modifies if it's gained or lost)
end

local UpdCurrencyLoot = function(tbl, data)
  if not data[1] then return end -- no currency name, no currency entry!
  if type(tbl[data[3]]) ~= "table" then tbl[data[3]] = {} end
  if type(tbl[data[3]][data[1]]) ~= "table" then -- new currency, insert it
    tbl[data[3]][data[1]] = data
  else -- update currency count for person
    tbl[data[3]][data[1]][2] = tbl[data[3]][data[1]][2] + data[2]
  end
end

local UpdItemLoot = function(tbl, data)
  if not data[1] then return end -- no item name, no item entry!
  if bool(MiniLootDB.hideJunk) and data[1]:match(addon.grayColorTag) then return end -- if we are supposed to hide junk, hide it!
  if bool(MiniLootDB.hidePartyLoot) and data[3] ~= UnitName("player") then -- if we are supposed to hide party loot (under the threshold, also can't be our own loot), this is where we handle this function...
    if MiniLootDB.hidePartyLootThreshold == 8 or MiniLootDB.hidePartyLootThreshold > addon:getColorRankByTag(data[1]) then -- if threshold is disabled, or if it's higher than the item, hide it!
      if not addon:isItemQuestStarter(data[1], 1) then -- do not hide quest (starting) items (in case you forget to loot the mob that dropped it in the first place, think of it as a "hey dude, loot the corpse for a quest!" kind of nudge)
        return
      end
    end
  elseif bool(MiniLootDB.hideSoloLoot) and data[3] == UnitName("player") then -- if we are supposed to hide some of our own loot (under the threshold, also can't be someone elses loot), this is where we handle this function...
    if MiniLootDB.hideSoloLootThreshold == 8 or MiniLootDB.hideSoloLootThreshold > addon:getColorRankByTag(data[1]) then -- if threshold is disabled, or if it's higher than the item, hide it!
      if not addon:isItemQuestStarter(data[1], 1) then -- do not hide quest (starting) items (in case you forget to loot the mob that dropped it in the first place, think of it as a "hey dude, loot the corpse for a quest!" kind of nudge)
        return
      end
    end
  end
  local itemid = data[1]:match("item:(%d+)") or data[1] -- use this as key for the table (so stacks of the same item always end up at the same entry, not duplicates!) NOTE: only issue here is if there are several "of the" items, same itemid but various attributes, but luckily this isn't often met in the game anyway!
  if type(tbl[data[3]]) ~= "table" then tbl[data[3]] = {} end -- character doesn't exist, create a empty table for it
  if type(tbl[data[3]][itemid]) ~= "table" then -- new item, insert it
    tbl[data[3]][itemid] = data
  else -- existing item, add additional number of items to the counter field
    tbl[data[3]][itemid][2] = tbl[data[3]][itemid][2] + data[2]
  end
end

local UpdMoneyLoot = function(tbl, data)
  if not data[1] then return end -- no gold looted, no money entry!
  tbl[data[2]] = (tbl[data[2]] or 0) + MoneyStringToCopper(data[1]) -- insert or update gold value
end

local UpdRollData = function(tbl, data)
  if not data[1] then return end -- no item rolled for, no roll entry!
  if type(tbl[rollIndex]) ~= "table" then tbl[rollIndex] = {} end
  if type(tbl[rollIndex][data[1]]) ~= "table" then tbl[rollIndex][data[1]] = {} end
  local dise, greed, need = data[4] == 1, data[4] == 2, data[4] == 3
  if dise then
    tbl[rollIndex][data[1]][data[2]] = {3, data[3]}
  elseif greed then
    tbl[rollIndex][data[1]][data[2]] = {2, data[3]}
  elseif need then
    tbl[rollIndex][data[1]][data[2]] = {1, data[3]}
  else
    tbl[rollIndex][data[1]][data[2]] = {0, 0}
  end
end

local OnEvent = function(worker, event, message, ...)
  -- make the interval skip until we have waited some seconds between the events
  addon.lastevent = GetTime()
  -- patch event, ptbl contains metadata while found contains the match return
  local temp, found, ptbl, matches, breakloop
  matches = addon.matches[event]
  for i = 1, #matches do
    if breakloop then
      break
    end
    for matcher, tbl in pairs(matches[i]) do
      temp = {message:match(matcher)}
      if #temp > 0 then
        found = temp
        ptbl = tbl
        breakloop = matcher
      end
    end
  end
  -- abort if no pattern matched the message (message is not important, I guess...)
  if not found or not ptbl then
    return --_print("[DEBUG]", event, message)
  end
  -- debug dump what we have matched
  --_print("[DEBUG0]", event) _print("[DEBUG1]", message) _print("[DEBUG2]", breakloop)
  -- abort if we are supposed to hide this kind of events
  if MiniLootDB.hideEvents[event] then
    return --_print("[DEBUG]", event, message, "(matched filter, will not be shown!)")
  end
  -- create the nessecary table structure
  if type(addon.queue[event]) ~= "table" then
    addon.queue[event] = {}
  end
  -- appropriately store the information we got
  if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
    UpdRepLoot(addon.queue[event], {
      ptbl[1] and found[ptbl[1]],
      ptbl[2] and tonumber(found[ptbl[2]]) or 0,
      ptbl[3] and 1 or -1,
    })
  elseif event == "CHAT_MSG_COMBAT_HONOR_GAIN" then
    UpdHonorLoot(addon.queue[event], {
      ptbl[1] and tonumber(found[ptbl[1]]) or 0,
      ptbl[2] and found[ptbl[2]] or "",
      ptbl[3] and tonumber(found[ptbl[3]]) or 0,
    })
  elseif event == "CHAT_MSG_COMBAT_XP_GAIN" then
    UpdXPLoot(addon.queue[event], {
      ptbl[1] and tonumber(found[ptbl[1]]) or 0,
      ptbl[2] and found[ptbl[2]] or "",
      ptbl[3] and -1 or 1,
    })
  elseif event == "CHAT_MSG_CURRENCY" then
    UpdCurrencyLoot(addon.queue[event], {
      ptbl[1] and found[ptbl[1]],
      ptbl[2] and tonumber(found[ptbl[2]]) or 1,
      ptbl[3] and validPlayerName(found[ptbl[3]]) or UnitName("player"),
    })
  elseif event == "CHAT_MSG_LOOT" then
    if ptbl[5] and (ptbl[1] and found[ptbl[1]]) then
      if bool(MiniLootDB.showRollDecisions) and whenInRF(not bool(MiniLootDB.hideLFRRollDecisions)) then
        local item = ptbl[1] and found[ptbl[1]]
        local plr = ptbl[2] and validPlayerName(found[ptbl[2]]) or UnitName("player")
        if bool(MiniLootDB.showRollIcons) then
          item = GetIconWithLink(item)
        end
        if ptbl[3] == 4 then
          print(format("%s |cff%s%s: %s|r ", item, "CCCCCC", FRIENDS_FRIENDS_CHOICE_EVERYONE, PASS))
        elseif ptbl[3] == 5 then
          if not (GetCVarBool("autoOpenLootHistory") or (isMasterLoot and IsMasterLooter())) then
            print(format("%s |cff%s|HlootHistory:%d|h[%s...]|h|r ", item, "CCCCCC", found[ptbl[2]], BONUS_ROLL_ROLLING))
          end
        elseif ptbl[3] == 6 then
          print(format("%s |cff%s%s %s|r ", item, "CCCCCC", plr, L.CHAT_WON))
        else
          if bool(MiniLootDB.classColors) then
            print(format("%s |cff%s%s|r|cff%s: %s|r ", item, addon:ClassColor(plr), plr, (ptbl[3] == 1 and "EE3333") or (ptbl[3] == 2 and "CCCC33") or (ptbl[3] == 3 and "33EE33") or "CCCCCC", (ptbl[3] == 1 and ROLL_DISENCHANT) or (ptbl[3] == 2 and GREED) or (ptbl[3] == 3 and NEED) or PASS))
          else
            print(format("%s |cff%s%s: %s|r ", item, (ptbl[3] == 1 and "EE3333") or (ptbl[3] == 2 and "CCCC33") or (ptbl[3] == 3 and "33EE33") or "CCCCCC", plr, (ptbl[3] == 1 and ROLL_DISENCHANT) or (ptbl[3] == 2 and GREED) or (ptbl[3] == 3 and NEED) or PASS))
          end
        end
      end
    elseif ptbl[4] then
      if bool(MiniLootDB.showRollSummary) and whenInRF(not bool(MiniLootDB.hideLFRRollSummary)) then
        UpdRollData(addon.queue[event], {
          ptbl[1] and found[ptbl[1]],
          ptbl[2] and validPlayerName(found[ptbl[2]]) or UnitName("player"),
          ptbl[3] and tonumber(found[ptbl[3]]) or 0,
          tonumber(ptbl[4]) or 0,
        })
      end
    else
      UpdItemLoot(addon.queue[event], {
        ptbl[1] and found[ptbl[1]],
        ptbl[2] and tonumber(found[ptbl[2]]) or 1,
        ptbl[3] and validPlayerName(found[ptbl[3]]) or UnitName("player"),
      })
    end
  elseif event == "CHAT_MSG_MONEY" then
    UpdMoneyLoot(addon.queue[event], {
      ptbl[1] and found[ptbl[1]],
      ptbl[2] and validPlayerName(found[ptbl[2]]) or UnitName("player"),
    })
  elseif event == "CHAT_MSG_COMBAT_GUILD_XP_GAIN" then
    UpdXPLoot(addon.queue[event], {
      ptbl[1] and tonumber(found[ptbl[1]]) or 0,
      GetGuildInfo("player") or GUILD,
      1,
    })
  --else
  --  _print("[DEBUG]", event, message)
  end
end

local ChatFilter_PetBattle = function(chatFrame, event, ...)
  if chatFrame == GetSelectedWindow() then return true end -- block all events in ChatFrame1 (addon handles that window)
  return false, ...
end

function worker:PetBattlesToggle(enabled)
  if enabled then
    ChatFrame_AddMessageEventFilter("CHAT_MSG_PET_BATTLE_COMBAT_LOG", ChatFilter_PetBattle)
    ChatFrame_AddMessageEventFilter("CHAT_MSG_PET_BATTLE_INFO", ChatFilter_PetBattle)
    worker:RegisterEvent("CHAT_MSG_PET_BATTLE_COMBAT_LOG")
    worker:RegisterEvent("CHAT_MSG_PET_BATTLE_INFO")
    worker:RegisterEvent("PET_BATTLE_CLOSE")
    worker:RegisterEvent("PET_BATTLE_OPENING_START")
    worker:RegisterEvent("PET_BATTLE_OVER")
    worker:RegisterEvent("PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE")
  else
    ChatFrame_RemoveMessageEventFilter("CHAT_MSG_PET_BATTLE_COMBAT_LOG", ChatFilter_PetBattle)
    ChatFrame_RemoveMessageEventFilter("CHAT_MSG_PET_BATTLE_INFO", ChatFilter_PetBattle)
    worker:UnregisterEvent("CHAT_MSG_PET_BATTLE_COMBAT_LOG")
    worker:UnregisterEvent("CHAT_MSG_PET_BATTLE_INFO")
    worker:UnregisterEvent("PET_BATTLE_CLOSE")
    worker:UnregisterEvent("PET_BATTLE_OPENING_START")
    worker:UnregisterEvent("PET_BATTLE_OVER")
    worker:UnregisterEvent("PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE")
  end
end

local OnPetBattleEvent = function(worker, event, message, ...)
  if not bool(MiniLootDB.petBattles) then return end
  if event == "CHAT_MSG_PET_BATTLE_COMBAT_LOG" then
    addon.petBattle:CombatLog(message)
  elseif event == "CHAT_MSG_PET_BATTLE_INFO" then
    addon.petBattle:CombatLog(message)
  elseif event == "PET_BATTLE_CLOSE" or event == "PET_BATTLE_OVER" then
    addon.petBattle.round = addon.petBattle.round - 1 -- fix a issue if printing now (new round fires once too many)
    addon.petBattle:PrintRoundSummary() -- any leftovers are printed now
    addon.petBattle:EndCombat() -- fires twice due to double events, use close for the real ending, over is fired right after the last round ends
  elseif event == "PET_BATTLE_OPENING_START" then
    addon.petBattle:NewRound(true)
  elseif event == "PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE" then
    addon.petBattle:PrintRoundSummary(tonumber(message) == 0)
    addon.petBattle:NewRound()
  end
end

local OnMailHooked

local OnMail_AutoLootMailItem = function(mailId)
  if OnMailHooked then
    local copper, _, _, items = select(5, GetInboxHeaderInfo(mailId))
    if not IsAddOnLoaded("EasyMail") and copper and copper > 0 then -- avoid EasyMail until it breaks completely (considering it's outdated :P)
      OnEvent(worker, "CHAT_MSG_MONEY", format(YOU_LOOT_MONEY, GetDenominationsFromCopper(copper)))
    end
    if items then
      local link, count
      for i = 1, items do
        link, count = GetInboxItemLink(mailId, i), select(3, GetInboxItem(mailId, i))
        if link and count then
          count = count < 1 and 1 or count
          OnEvent(worker, "CHAT_MSG_LOOT", format(LOOT_ITEM_PUSHED_SELF_MULTIPLE, link, count or 1))
        end
      end
    end
  end
end

local OnMail_TakeInboxItem = function(mailId, attachId)
  if OnMailHooked then
    local link, count = GetInboxItemLink(mailId, attachId), select(3, GetInboxItem(mailId, attachId))
    if link and count then
      count = count < 1 and 1 or count
      OnEvent(worker, "CHAT_MSG_LOOT", format(LOOT_ITEM_PUSHED_SELF_MULTIPLE, link, count or 1))
    end
  end
end

local OnMail_TakeInboxMoney = function(mailId)
  if OnMailHooked then
    local copper = select(5, GetInboxHeaderInfo(mailId))
    if not IsAddOnLoaded("EasyMail") and copper and copper > 0 then -- avoid EasyMail until it breaks completely (considering it's outdated :P)
      OnEvent(worker, "CHAT_MSG_MONEY", format(YOU_LOOT_MONEY, GetDenominationsFromCopper(copper)))
    end
  end
end

local OnMailEvent = function(worker, event, ...)
  if event == "MAIL_SHOW" and bool(MiniLootDB.mailboxLoot) then
    OnMailHooked = 1
  elseif event == "MAIL_CLOSED" then
    OnMailHooked = nil
  end
end

local OnTradeAccepted

local OnTradeEvent = function(worker, event, ...)
  if not bool(MiniLootDB.tradeLoot) then
    return
  end
  if event == "TRADE_SHOW" then
    OnTradeAccepted = nil
    worker:RegisterEvent("TRADE_ACCEPT_UPDATE")
    worker:RegisterEvent("TRADE_REQUEST_CANCEL")
    worker:RegisterEvent("TRADE_CLOSED")
  elseif event == "TRADE_ACCEPT_UPDATE" then
    local accept1, accept2 = ...
    OnTradeAccepted = (accept1 == 1 or accept2 == 1) and 1 or nil -- both will be accepted simulatenously
  elseif event == "TRADE_REQUEST_CANCEL" then
    OnTradeAccepted = nil
  elseif event == "TRADE_CLOSED" then
    if OnTradeAccepted then
      local copper = GetTargetTradeMoney() or 0
      if copper > 0 then
        OnEvent(worker, "CHAT_MSG_MONEY", format(YOU_LOOT_MONEY, GetDenominationsFromCopper(copper)))
      end
      for i = 1, MAX_TRADE_ITEMS - 1 do -- skip "won't be traded" slot
        local link, count = GetTradeTargetItemLink(i), select(3, GetTradeTargetItemInfo(i))
        if link then
          OnEvent(worker, "CHAT_MSG_LOOT", format(LOOT_ITEM_PUSHED_SELF_MULTIPLE, link, count or 1))
        end
      end
    end
    OnTradeAccepted = nil
    worker:UnregisterEvent("TRADE_ACCEPT_UPDATE")
    worker:UnregisterEvent("TRADE_REQUEST_CANCEL")
    worker:UnregisterEvent("TRADE_CLOSED")
  end
end

local HookChatEvents = function()
  -- register our events and apply filtering and parsing of messages
  for event, _ in pairs(addon.matches) do
    ChatFrame_AddMessageEventFilter(event, function(chatFrame, event, ...)
      if chatFrame == GetSelectedWindow() then
        if (not bool(MiniLootDB.petBattles)) and event:match("PET_BATTLE") then
          return false, ... -- allow pet battle messages at this point
        end
        return true
      end
      return false, ...
    end)
    addon.events[event] = OnEvent
    worker:RegisterEvent(event)
  end
  -- block and parse certain special system messages
  ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", function(chatFrame, event, msg, ...)
    if chatFrame == GetSelectedWindow() and msg:find(FormatToMatcher(ERR_QUEST_REWARD_MONEY_S)) then OnEvent(worker, "CHAT_MSG_MONEY", format(YOU_LOOT_MONEY, msg), ...) return true end -- simulate gold loot event (and stop the message from showing up)
    if chatFrame == GetSelectedWindow() and msg:find(FormatToMatcher(ERR_QUEST_REWARD_EXP_I)) then return true end -- stop "Experience gained: %d." messages from showing
    local itemlink, byname = msg:match(FormatToMatcher(LOOT_DISENCHANT_CREDIT))
    --if chatFrame == GetSelectedWindow() and itemlink then return true end -- uncomment this line to hide all "X was disenchanted for loot by Y" messages, otherwise replaces item link with icon and keeps it as minimal as possible
    if chatFrame == GetSelectedWindow() and itemlink then return false, format(LOOT_DISENCHANT_CREDIT, GetIconWithLink(itemlink), byname), ... end
    return false, msg, ...
  end)
  -- add support for pet battles (the events are registered in opts.lua)
  addon.events.CHAT_MSG_PET_BATTLE_COMBAT_LOG = OnPetBattleEvent
  addon.events.CHAT_MSG_PET_BATTLE_INFO = OnPetBattleEvent
  addon.events.PET_BATTLE_CLOSE = OnPetBattleEvent
  addon.events.PET_BATTLE_OPENING_START = OnPetBattleEvent
  addon.events.PET_BATTLE_OVER = OnPetBattleEvent
  addon.events.PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE = OnPetBattleEvent
  -- mailbox looting
  addon.events.MAIL_SHOW = OnMailEvent
  addon.events.MAIL_CLOSED = OnMailEvent
  worker:RegisterEvent("MAIL_SHOW")
  worker:RegisterEvent("MAIL_CLOSED")
  hooksecurefunc("AutoLootMailItem", OnMail_AutoLootMailItem)
  hooksecurefunc("TakeInboxItem", OnMail_TakeInboxItem)
  hooksecurefunc("TakeInboxMoney", OnMail_TakeInboxMoney)
  -- trade looting
  addon.events.TRADE_SHOW = OnTradeEvent
  addon.events.TRADE_ACCEPT_UPDATE = OnTradeEvent
  addon.events.TRADE_REQUEST_CANCEL = OnTradeEvent
  addon.events.TRADE_CLOSED = OnTradeEvent
  worker:RegisterEvent("TRADE_SHOW")
end

local GenerateChatReport = function()
  local str, lastname, temp, event, entries = "", ""
  local sorted, order = {}, { -- defines the order output is printed
    "CHAT_MSG_COMBAT_XP_GAIN",
    "CHAT_MSG_COMBAT_GUILD_XP_GAIN",
    "CHAT_MSG_COMBAT_FACTION_CHANGE",
    "CHAT_MSG_COMBAT_HONOR_GAIN",
    "CHAT_MSG_MONEY",
    "CHAT_MSG_CURRENCY",
    "CHAT_MSG_LOOT",
  }
  for _, orderEvent in ipairs(order) do
    temp = addon.queue[orderEvent]
    if temp then
      table.insert(sorted, {orderEvent, temp})
    end
  end
  for _, entryData in ipairs(sorted) do
    event, entries = unpack(entryData)
    -- experience
    if event == "CHAT_MSG_COMBAT_XP_GAIN" then
      --lastname = ""
      str = str..format("|cffFFFF00%s: %d|r ", XP, select(2, next(entries)))
    -- guild experience
    elseif event == "CHAT_MSG_COMBAT_GUILD_XP_GAIN" then
      --lastname = ""
      str = str..format("|cffFFFF00%s%s: %d|r ", GUILD:sub(1, 1):len() > 0 and GUILD:sub(1, 1) or GUILD:sub(1, 2), XP, select(2, next(entries)))
    -- reputation
    elseif event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
      --lastname = ""
      for k, v in pairs(entries) do
        if v > 0 then
          str = str..format("|cff9696FF%s|r|cff%s+%d|r ", Abbrev(k), "00FF00", v)
        elseif v < 0 then
          str = str..format("|cff9696FF%s|r|cff%s%d|r ", Abbrev(k), "FF0000", v) -- removed "-" as prefix as the %d automatically adds it when negative value!
        end
      end
    -- honor
    elseif event == "CHAT_MSG_COMBAT_HONOR_GAIN" then
      --lastname = ""
      temp = format("%.2f", select(2, next(entries)))
      if (tonumber(temp) or 0) > 0 then -- do not show when you gain 0 honor (or 0.001...)
        str = str..format("|cff9696FF%s: %s|r ", HONOR, temp)
      end
    -- currency
    elseif event == "CHAT_MSG_CURRENCY" then
      for plr, currencies in pairs(entries) do
        if lastname ~= plr then
          str = str..format("|cff%s%s|r|cffFFFF00:|r ", addon:ClassColor(plr), plr)
          lastname = plr
        end
        temp = 0
        if type(currencies) == "table" then
          for _, curr in pairs(currencies) do
            if type(curr) == "table" then
              curr[2] = tonumber(curr[2]) or 1 -- TODO: WIP
              if bool(MiniLootDB.lootCount) then
                str = str..format("%s%s%s ", GetIconWithLink(curr[1], 1), curr[2] > 1 and "x"..curr[2] or "", addon:GetCurrencyCount(curr[2], curr[1]))
              else
                str = str..format("%s%s ", GetIconWithLink(curr[1], 1), curr[2] > 1 and "x"..curr[2] or "")
              end
              temp = temp + 1
            else -- no table, thus a "_" entry with only a item and nothing else (NYI)
              if bool(MiniLootDB.lootCount) then
                str = str..format("%s%s ", GetIconWithLink(curr, 1), addon:GetCurrencyCount(1, curr))
              else
                str = str..format("%s ", GetIconWithLink(curr, 1))
              end
              temp = temp + 1
            end
          end
        end
        if temp == 0 then
          str = str..format("|cff999999(%s)|r ", L.CHAT_NO_LOOT)
        end
      end
    -- items (and rolls)
    elseif event == "CHAT_MSG_LOOT" then
      local sortedentries = {}
      for plr, items in pairs(entries) do
        table.insert(sortedentries, {plr, items})
      end
      table.sort(sortedentries, function(a, b) return a[1] < b[1] end)
      for i = 1, #sortedentries do
        local plr, items = unpack(sortedentries[i])
        if plr == rollIndex then -- special table containing roll data (safe because no player can use this as a name)
          lastname = "" -- to avoid having an item printed without who looted it (when rolls appear first and then we loot the item, this can look a bit weird, hence this fix)
          if type(items) == "table" then
            str = NewLine(str) -- before rolls start we add a new line to separate them
            for item, rolldata in pairs(items) do
              if bool(MiniLootDB.showRollIcons) then
                item = GetIconWithLink(item)
              end
              str = str..format("|cff00AA00%s|r %s|cff00AA00:|r ", L.CHAT_ROLL, item) -- BUG: "Wurf un" but this string is used by options for the word "Roll"
              local hasNeed, hasBonus, hadBonus -- "hasNeed" kind of obscolete I reckon... but I am so lazy right now!
              local sortedrolls = {}
              for plr, roll in pairs(rolldata) do
                if roll[1] == 1 then hasNeed = 1 end
                roll[3], hadBonus = stripNameRollBonus(plr) -- use this to store playername (strip away the " + Roll Bonus" junk in LFR)
                if hadBonus then hasBonus = 1 end
                table.insert(sortedrolls, roll)
              end
              table.sort(sortedrolls, function(a, b) return tonumber(a[2]) > tonumber(b[2]) end)
              local color, suffix
              for _, roll in pairs(sortedrolls) do
                if roll[3] == UnitName("player") or ((not hasNeed) or (hasNeed and roll[1] == 1)) and ((not hasBonus) or (hasBonus and roll[2] > 100)) then -- always show our own rolls, or if the filtering is okay with it...
                  if roll[1] == 1 then
                    color = "33EE33"
                    suffix = L.CHAT_ROLL_N -- short for "Need"
                  elseif roll[1] == 2 then
                    color = "CCCC33"
                    suffix = L.CHAT_ROLL_G -- short for "Greed"
                  elseif roll[1] == 3 then
                    color = "EE3333"
                    suffix = L.CHAT_ROLL_D -- short for "Dissenchant"
                  else
                    color = "CCCCCC"
                    suffix = L.CHAT_ROLL_P -- short for "Pass"
                  end
                  if bool(MiniLootDB.classColors) then
                    str = str..format("|cff%s%s|r|cff%s:%s:%d|r ", addon:ClassColor(roll[3]), roll[3], color, suffix, roll[2])
                  else
                    str = str..format("|cff%s%s:%s:%d|r ", color, roll[3], suffix, roll[2])
                  end
                end
              end
              str = NewLine(str) -- each roll has it's own line
            end
          end
        else -- handle item data since it's not a roll entry...
          if lastname ~= plr then
            str = str..format("|cff%s%s|r|cffFFFF00:|r ", addon:ClassColor(plr), plr)
            lastname = plr
          end
          temp = 0
          if type(items) == "table" then
            for _, item in pairs(items) do
              if type(item) == "table" then
                item[2] = tonumber(item[2]) or 1 -- TODO: WIP
                if plr == UnitName("player") and bool(MiniLootDB.lootCount) then
                  str = str..format("%s%s%s ", GetIconWithLink(item[1]), item[2] > 1 and "x"..item[2] or "", addon:GetItemCount(item[2], item[1], true, true))
                else
                  str = str..format("%s%s ", GetIconWithLink(item[1]), item[2] > 1 and "x"..item[2] or "")
                end
              else -- no table, thus a "_" entry with only a item and nothing else (TODO: WIP)
                if plr == UnitName("player") and bool(MiniLootDB.lootCount) then
                  str = str..format("%s%s ", GetIconWithLink(item), addon:GetItemCount(1, item, true, true))
                else
                  str = str..format("%s ", GetIconWithLink(item))
                end
              end
              temp = temp + 1
            end
          end
          if temp == 0 then
            str = str..format("|cff999999(%s)|r ", L.CHAT_NO_LOOT)
          end
        end
      end
    -- gold
    elseif event == "CHAT_MSG_MONEY" then
      for plr, copper in pairs(entries) do
        if tonumber(copper or 0) > 0 then -- weird bug, causes "0 copper" to be printed sometimes!
          if lastname ~= plr then
            str = str..format("|cff%s%s|r|cffFFFF00:|r ", addon:ClassColor(plr), plr)
            lastname = plr
          end
          str = str..format("|cffFFFF00%s|r ", GetCoinTextureString(copper))
        end
      end
    end
  end
  if str:len() > 3 then -- only output the string if it contains something proper, tough it should never contain only 1 or 2 chars...
    local lines = {("\n"):split(str)} -- instead of having many lines in 1 message, split them up (icons bug otherwise!)
    for _, line in pairs(lines) do
      line = line:trim() -- trim spacing on the left and right edges
      if line:len() > 3 then -- avoid empty strings like empty line at the end...
        print(line) -- output the summary
      end
    end
  end
end

local OnUpdate = function(worker, elapsed)
  if InCombatLockdown() and MiniLootDB.sleepAfterCombat ~= -1 then return end -- wait for combat to end (ignore if sleep is -1)
  if (not addon.lastevent) then return end -- nothing to report? wait...
  worker.elapsed = (worker.elapsed or 0) + elapsed -- keep counting now!
  if GetTime()-addon.lastevent < MiniLootDB.sleepBetweenEvents then return end -- wait for last event timer to expire
  if worker.elapsed >= MiniLootDB.sleepAfterCombat then
    GenerateChatReport()
    table.wipe(addon.queue)
    worker.elapsed = 0
    addon.lastevent = nil
  end
end

addon.init = function(addon, force)
  if not force and (type(addon.loaded) ~= "table" or #addon.loaded < 2) then return end -- already init.
  addon.loaded = nil
  local reset = addon:variablecheck()
  if reset ~= 0 then
    _print(format(L.CHAT_SETTINGS_RESET, addon.name2, reset))
  end
  addon.events.LOOT_OPENED = function(worker, event) addon.lastevent = GetTime() end
  addon.events.LOOT_CLOSED = function(worker, event) addon.lastevent = GetTime() end
  worker:RegisterEvent("LOOT_OPENED")
  worker:RegisterEvent("LOOT_CLOSED")
  ConvertMatches()
  HookChatEvents()
  worker:SetScript("OnUpdate", OnUpdate)
  addon:loadCfgUI(worker)
  do
    local orig1 = ItemRefTooltip.SetHyperlink -- we have to hook this function since the default ChatFrame code assumes that all links except for player and channel links are valid arguments for this function
    function ItemRefTooltip:SetHyperlink(link, ...)
      if link:match("^"..addon.name2) then return end
      return orig1(self, link, ...)
    end
    local orig2 = SetItemRef -- we have to hook this function to make currency from the chat linkable
    function SetItemRef(link, text, button, chatFrame, ...)
      local curID = tonumber(link:match("currency:(%d+)"))
      if curID and curID > 0 and IsModifiedClick() then
        text = GetCurrencyLink(curID) or text
      end
      return orig2(link, text, button, chatFrame, ...)
    end
  end
end

addon.events.ADDON_LOADED = function(worker, event, name)
  if addon.name == name then
    worker:UnregisterEvent("ADDON_LOADED")
    if type(addon.loaded) == "table" then table.insert(addon.loaded, event) end
  end
  addon:init()
end

addon.events.CURRENCY_DISPLAY_UPDATE = function(worker, event, ...)
  CurrencyCaches()
  ArchaeologyCaches() -- run last as this appends to the currency cache
end

addon.events.VARIABLES_LOADED = function(worker, event)
  worker:UnregisterEvent("VARIABLES_LOADED")
  if type(addon.loaded) == "table" then table.insert(addon.loaded, event) end
  addon:init()
end

worker:SetScript("OnEvent", function(worker, event, ...)
  addon.events[event](worker, event, ...)
end)

for k, _ in pairs(addon.events) do
  worker:RegisterEvent(k)
end

if addon.name ~= addon.name2 then
  addon:init(1) -- force init() in case addon is loaded as a child-addon
end
